<?php
/* GLOBAL PARAMETERS FOR FsPlistflight.php */ 

$ver = "2.0.1";
// 2006-01-04
// FSP List Flight php script, based on script written by Daniel Polli, Peter Schindler and Andrea Cocco.
// Feel free modify as you like but please let authors names stay if you pass it along
// Jens Roos, Sweden, visit my VA page for examples http://www.race.d2g.com/selva/sv/fsplistflight.php
// email question and/or suggestions to race@bredband.net

/////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
// the following arrays list the columns and the corresponding database field-names showing up in the table  // 
// you can add more columns/fields or remove those you don't wish to display or sort them in a different way // 
// Note: the two arrays must have the same number of values; values must be separated by comma               // 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

// Columns and header of flights data, column names must be the same in main query
$tableColumns = 'Flight Nr,Date,Company,Pilot,From,To,PAX,Type,Time,Result,Bonus,Penalty';
$dataFields = 	'FlightId,FlightDate,CompanyName,PilotName,DepartureIcaoName,ArrivalIcaoName,NbrPassengers,AircraftType,TotalBlockTime,FlightResult,BonusPoints,PenalityPoints';
$FormatFlights = 'x,x,x,x,s,s,0,x,x,x,0,0';	// Se description $FormatCells in setting_group.php

/////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////// GET GROUP PARAMETERS FROM FILE ////////////////////////////////////// 

$action = $_GET['action'];
# setting_group.php contains custom settings for all lists
require("fsplistcfg.php");

/////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////// GLOBAL PARAMETERS CHANGE THESE AS YOU LIKE ////////////////////////////////////// 

$SortFlight = 'FlightDate desc, datestamp desc';		// you can set this to 'FlightDate', 'CompanyName' or whatever you like
								// add 'desc' to sort the data in descending order                 
# colors 
$oddColor = '#D5E4FD';						// 1st background color of alternating table rows 
$evenColor = '#fcf9e4'; 					// 2nd background color of alternating table rows 
$linkColor = '#000099';						// font color for linked items (in this case just first column)

# set a start date (referring to upload-date) for the records to be displayed, starting with that date 
# this is optional, leave it empty (default) to display all records in the database 
$startDate = '';						// if not empty, the date must be entered in a given format 
								// (YYYY-MM-DD) and it has to be valid - ex.: '2005-05-30'
# Headline on top of page 
$PageTitle	= 'Virtual Airline - '.$pageText;               // Adds selection above to text

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////NEEDED STUFF USUALLY YOU WILL NOT NEED TO CHANGE THIS///////////////////////////////////
define("FSP", 1);
# setting.php contains MySQL database settings and other settings; it contains also the FSP UNIT SETTING
require("fspadmin/setting.php");			
# common.php do the connection to MySQL the value $databaseconnexion is set to true if the connection is okay
require("fspadmin/common.php");	
// the value "$databaseconnexion" is set to true in common.php if the connexion is ok
if($databaseconnexion==FALSE){echo "Error - unable to connect to mySQL database;";return;}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

// get the header-variables GET / POST 
$listflight = $_GET['listflight'];		// ID of a single selected flight
$Groupflight = $_GET['groupflight'];		// ID of a grouped flights
$s = $_GET['s'];				// sorting option (column) 
$d = $_GET['d'];				// sorting direction (ASCENDING or DESCENDING) 
$p = $_GET['p'];				// actual page to display 

if (isset($listflight)) $action="";

// create where statement for grouped data
$GroupByArray = explode(",",$dbGroupBy);
for($i=0;$i<count($GroupByArray);$i++) {
	$GroupByArray[$i] = trim($GroupByArray[$i]);
}
$GroupArray = explode(",",$Groupflight);
for($i=0;$i<count($GroupArray);$i++) {
	$GroupArray[$i] = trim($GroupArray[$i]);
}
if ($action!="ALLFLIGHTS") {
	$GroupWhere = "WHERE ";
	for($i=0;$i<count($GroupArray);$i++) {
		if ($i>0) $GroupWhere = "$GroupWhere AND ";
		$GroupWhere = "$GroupWhere$GroupByArray[$i] LIKE '$GroupArray[$i]'";
	}
}
// create the arrays for the column names and database fields from config.php 
$columnNames = explode(",",$tableColumns);
$GroupColumnNames = explode(",",$GroupColumns);
$GroupFieldNames = explode(",",$GroupFields);
for($i=0;$i<count($GroupFieldNames);$i++) {
	$GroupFieldNames[$i] = trim($GroupFieldNames[$i]);
}
$FormatFlight = explode(",",$FormatFlights);
for($i=0;$i<count($FormatFlight);$i++) {
	$FormatFlight[$i] = trim($FormatFlight[$i]);
}
$dbFieldNames = explode(",",$dataFields);
for($i=0;$i<count($dbFieldNames);$i++) {
	$dbFieldNames[$i] = trim($dbFieldNames[$i]);
}
$AlignCell = explode(",",$AlignCells);
for($i=0;$i<count($AlignCell);$i++) {
	$AlignCell[$i] = trim($AlignCell[$i]);
}
$FormatCell = explode(",",$FormatCells);
for($i=0;$i<count($FormatCell);$i++) {
	$FormatCell[$i] = trim($FormatCell[$i]);
}

// set the sql condition for start date selected, if any 
$condition = '';
$andCondition = '';
if($startDate != '')
{
	$startMsg = ' since '.$startDate;
	$startDate .= ' 00:00:00';
	$condition = "where datestamp>=str_to_date('".$startDate."','%Y-%m-%d %H:%i:%s')";
	$andCondition = "and datestamp>=str_to_date('".$startDate."','%Y-%m-%d %H:%i:%s')";
} 

// avoid invalid options for $d 
if ($d!=1) $d=0;

// Add grouping and filters to group query
$mainQuery = "$mainQuery FROM flights $dbWhere GROUP BY $dbGroupBy";

// SORTING //////////////////////////////////////////////////////////////////////////////////////////////////// 
if($s=="") 
{
	if( (!isset($listflight)) and (!isset($Groupflight)) and $action!="ALLFLIGHTS")
	{
		$sortColumn = $SortGroup;
	} else {
		$sortColumn = $SortFlight;
	}
} else {

	
	$sortColumn = $s;
	if($d==0) {
		$sortOptions[$sortColumn] = 1;
		$sortColumn .= ' desc';
	}
	if($sortColumn!=$dbGroup && $sortColumn!=$dbGroup.' desc')
	{
		$sortColumn .= ", $dbGroup";
	}
}
if( (!isset($listflight)) and (!isset($Groupflight)) and $action!="ALLFLIGHTS")
{
	$pageLines = $pageGroup;
} else {
	$pageLines = $pageFlight;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

///////////////////// EDIT THE TABLE DESIGN HERE ////////////////////////////////////////////////////////////// 
$ListStart	='<table width="'.$tableWidth.'" cellspacing="1" cellpadding="2" align="center" style="font: normal 11px/14px Arial,sans-serif;padding:2px 7px 2px 7px">';
$TDTitStyle ='<td nowrap style="background-color:#5F7EEB;color:white;padding:2px 5px 2px 5px">';
$TDTitStyleList ='<td nowrap style="background-color:#5F7EEB;color:white;padding:2px 5px 2px 5px" colspan="2" align="center">';

$TableVA ='<tr>';
	// loop to create the column headers 
	for ($i=0;$i<count($GroupFieldNames);$i++) 
	{
		$TableVA .= $TDTitStyle.
		' <a href="?action='.$action.'&s='.$GroupFieldNames[$i].'&d='.$sortOptions[$GroupFieldNames[$i]].'&p='.$p.'" 
		style="text-decoration:none;color:white">'.$GroupColumnNames[$i].'</a></td>'.chr(13);
	}
$TableTitle ='<tr>';
	// loop to create the column headers 
	for ($i=0;$i<count($dbFieldNames);$i++) 
	{
		$TableTitle .= $TDTitStyle.
		' <a href="?action='.$action.'&groupflight='.$Groupflight.'&s='.$dbFieldNames[$i].'&d='.$sortOptions[$dbFieldNames[$i]].'&p='.$p.'" 
		style="text-decoration:none;color:white">'.$columnNames[$i].'</a></td>'.chr(13);
	}
$TDListOdd	='<td style="background-color:'.$oddColor.';color:black;padding-left:5px">';	// define here background and font colors of 
$TDListEven	='<td style="background-color:'.$evenColor.';color:black;padding-left:5px">';	// the alternating rows 
$TRList		='<tr>';
$ListStop	='</table>';
/////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

////////////////////////////////////// THIS IS THE LIST OVERVIEW ////////////////////////////////////////////// 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
if( ((!isset($listflight)) and (!isset($Groupflight))) or $action=="ALLFLIGHTS")
{
	// ------------------------------ INTRO-TEXT AND SELECTION HEADER --------------------------------- 
	// delete or edit as you like ... 
	echo	$TemplateStart;
	echo HtmlSelect();
	echo 	'<table align="center" border="0"><tr><td><br>
			<span style="font: bold 18px/24px Arial,sans-serif">
			'.$PageTitle.'
			</span><br>
			</td></tr></table>';
	// ------------------------------------------------------------------------------------------------ 
	
	echo VAStat();
	if ($action!="ALLFLIGHTS") {

	// ------------------------------ COMMENTS ------------------------------------------------------- 
	// delete or edit as you like ... 
	echo 	'<table align="center" cellspacing="2" cellpadding="2" border="0" style="font:normal 11px/14px Arial,sans-serif;color:#444444">
			<tr><td>Click on '.$helpText.' to show the list of flights. Click on the column headers to sort the data by columns.</td>
			</tr></table>';	
	// ------------------------------------------------------------------------------------------------ 
	
	
	// PAGING ///////////////////////////////////////////////////////////////////////////////////////// 
	//
	// set max page numbers displayed at a time (to avoid line breaks in the paging) 
	$maxPage = 20;
	$pageStep = 10;
	$pStart = 0;

	
		// preliminary  sql-query : 
		$query =  'SELECT   COUNT('.$dbGroup.') as TnF FROM flights '.$dbWhere.' GROUP  BY '.$dbGroupBy;
		if(!$result=mysql_query($query))
		{
				echo "SQL Error - ".mysql_error()."<br>".$query;
				return;
		} 
	
		/////////////////////////////////////////////////////////////////////////////////////////////////////// 
		$NrfFlights=mysql_num_rows($result);
		if($NrfFlights==0){echo "No flights to display";return;}
		
		$pages = ceil($NrfFlights/$pageLines);
		if(isset($p) && $p<=$pages) {$thisPage=$p;} else {$thisPage=0;}
		$pStart = $thisPage*$pageLines;
		$pEnd = $pStart+$pageLines;
		if($pEnd>$NrfFlights) $pEnd=$NrfFlights;
		
		// reduce the nbr of pages displayed at a time 
		if($pages > $maxPage) 
		{
			$pageFrom = $thisPage-$pageStep;
			if($pageFrom < 0) $pageFrom = 0;
			$pageTo = $pageFrom+$maxPage;
			if($pageTo > $pages) $pageTo = $pages;
		} 
		else 
		{
			$pageTo = $pages;
		}
		
		// create the HTML for the paging 
		$paging_Html = '<table width="'.$tableWidth.'" align="center" 
						style="font:normal 11px/14px Arial,sans-serif;background-color:white"><tr>'.chr(13);
		$paging_Html .= '<td valign="top" style="padding:4px 0px 4px 4px">Page&nbsp;&nbsp;';
		for ($i=$pageFrom;$i<$pageTo;$i++)
		{
			if($i == $thisPage)
			{
				$paging_Html .= '<span style="font-weight:bold">'.($i+1).'</span>&nbsp;&nbsp;'.chr(13);
			} else {
				$paging_Html .= '<a href="?action='.$action.'&s='.$s.'&d='.$d.'&p='.$i.'" style="color:'.$linkColor.'">'.($i+1).'</a>&nbsp;&nbsp;'.chr(13);
			}
		}
		if ($thisPage+1!=$pages)
		{
			$paging_Html .= '<a href="?action='.$action.'&s='.$s.'&d='.$d.'&p='.($thisPage+1).'" style="color:'.$linkColor.'">next&nbsp;&raquo;</a>';
		}
		$paging_Html .= '</td><td valign="top" align="right" style="padding:4px 4px 4px 0px"">
						Displaying '.$returnText.' '.($pStart+1).' to '.$pEnd.' of a total '.$NrfFlights.'</td>';
		$paging_Html .= '</tr></table>';
		//////////////////////////////////////////////////////////////////////////////////////////////////////
		// main sql-query : 
		
		$query = "$mainQuery ORDER BY $sortColumn LIMIT $pStart,$pageLines";

		if(!$result=mysql_query($query))
		{
				echo "SQL Error - ".mysql_error()."<br>".$query;
				return;
		} 
	        ///////////////////////////////////////////////////////////////////////////////////////////////////////
		///////////////////// LIST TABLE OUTPUT /////////////////////////////////////////////////////////////// 
	echo $paging_Html;
	
	echo $ListStart.$TableVA;
	
	if ($NrfFlights>0) {
		$Line=0;
		// loop to display all rows 
		while ($row = mysql_fetch_assoc($result)) 
			{
			echo $TRList;
			// loop to display all columns using function "makeTD1()" 
			$GroupTxt = "";
			for($i=0;$i<count($GroupByArray);$i++) {
				for($z=0;$z<count($GroupFieldNames);$z++) {
					if ($GroupFieldNames[$z] == $GroupByArray[$i]) {
						if ($i>0) $GroupTxt .= ",";
						$GroupTxt = $GroupTxt.$row[$GroupFieldNames[$z]];
						break 1;
					}
				}
			}
			for($i=0;$i<count($GroupFieldNames);$i++) 
			{
				$data = $row[$GroupFieldNames[$i]];
				if ($GroupFieldNames[$i]==$dbGroup)
			  	{
			  		echo makeTD1($data,$GroupFieldNames[$i],$Line,$FormatCell[$i],$AlignCell[$i],$GroupTxt);	// this TD is linked by FlightId 
				} else {
				  	echo makeTD1($data,$GroupFieldNames[$i],$Line,$FormatCell[$i],$AlignCell[$i]);
				}
			}
			echo '</tr>';
			$Line=!$Line;		
		}
	} 
	else 
	{
		echo '<tr><td colspan="'.count($GroupFieldNames).'" align="center"><br>There are no flights recorded.</td></tr>';
	}
	
	echo $ListStop;
	
	echo $paging_Html;
	echo $TemplateEnd;
	/////////////////////////////////////////////////////////////////////////////////////////////////////// 
	}

}

if( (!isset($listflight)) and (!isset($Groupflight)) and $action!="ALLFLIGHTS") return;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 


if(isset($Groupflight) or $action=="ALLFLIGHTS")
{
	
	// PAGING ///////////////////////////////////////////////////////////////////////////////////////// 
	//
	// set max page numbers displayed at a time (to avoid line breaks in the paging) 
	$maxPage = 20;
	$pageStep = 10;
	$pStart = 0;
	////////////////////////////////////////////////////////////////////////////////////////////////////////
		$query = "SELECT * FROM flights $GroupWhere $dbAndWhere";
		if(!$result=mysql_query($query))
		{
				echo "SQL Error - ".mysql_error()."<br>".$query;
				return;
		} 
	$NrfFlights=mysql_num_rows($result);
	if($NrfFlights==0){echo "No flights to display";return;}
	

	/////////////////////////////////////////////////////////////////////////////////////////////////////// 
	$pages = ceil($NrfFlights/$pageLines);
		if(isset($p) && $p<=$pages) {$thisPage=$p;} else {$thisPage=0;}
		$pStart = $thisPage*$pageLines;
		$pEnd = $pStart+$pageLines;
		if($pEnd>$NrfFlights) $pEnd=$NrfFlights;
		
		// reduce the nbr of pages displayed at a time 
		if($pages > $maxPage) 
		{
			$pageFrom = $thisPage-$pageStep;
			if($pageFrom < 0) $pageFrom = 0;
			$pageTo = $pageFrom+$maxPage;
			if($pageTo > $pages) $pageTo = $pages;
		} 
		else 
		{
			$pageTo = $pages;
		}
		
		// create the HTML for the paging 
		$paging_Html = '<table width="'.$tableWidth.'" align="center" 
						style="font:normal 11px/14px Arial,sans-serif;background-color:white"><tr>'.chr(13);
		$paging_Html .= '<td valign="top" style="padding:4px 0px 4px 4px">Page&nbsp;&nbsp;';
		for ($i=$pageFrom;$i<$pageTo;$i++)
		{
			if($i == $thisPage)
			{
				$paging_Html .= '<span style="font-weight:bold">'.($i+1).'</span>&nbsp;&nbsp;'.chr(13);
			} else {
				$paging_Html .= '<a href="?action='.$action.'&groupflight='.$Groupflight.'&s='.$s.'&d='.$d.'&p='.$i.'" style="color:'.$linkColor.'">'.($i+1).'</a>&nbsp;&nbsp;'.chr(13);
			}
		}
		if ($thisPage+1!=$pages)
		{
			$paging_Html .= '<a href="?action='.$action.'&groupflight='.$Groupflight.'&s='.$s.'&d='.$d.'&p='.($thisPage+1).'" style="color:'.$linkColor.'">next&nbsp;&raquo;</a>';
		}
		$paging_Html .= '</td><td valign="top" align="right" style="padding:4px 4px 4px 0px"">
						Displaying Flight '.($pStart+1).' to '.$pEnd.' of a total '.$NrfFlights.'</td>';
		$paging_Html .= '</tr></table>';
	///////////////////////////////////////////////////////////////////////////////////////////////////////
		$query = "SELECT * FROM flights $GroupWhere $dbAndWhere ORDER BY $sortColumn LIMIT $pStart,$pageLines";
		if(!$result=mysql_query($query))
		{
				echo "SQL Error - ".mysql_error()."<br>".$query;
				return;
		} 
	
	if ($action!="ALLFLIGHTS") {
	///////////////////// LIST TABLE OUTPUT /////////////////////////////////////////////////////////////// 
	// ------------------------------ INTRO-TEXT ----------------------------------------------------- 
	// delete or edit as you like ... 
	echo	$TemplateStart;
	echo HtmlSelect();
	echo 	'<table align="center" border="0"><tr><td><br>
			<span style="font: bold 18px/24px Arial,sans-serif">
			<center>LogBook of  '.$Groupflight.'</center>
			</span></td></tr>
			</td></tr></table>';
	// ------------------------------------------------------------------------------------------------ 
	}
	// ------------------------------ COMMENTS ------------------------------------------------------- 
	// delete or edit as you like ... 
	echo 	'<table align="center" cellspacing="2" cellpadding="2" border="0" style="font:normal 11px/14px Arial,sans-serif;color:#444444">
			<tr><td>Click on Flight Nr to show the details of one flight. Click on the column headers to sort the data by columns.</td>
			</tr></table>';	
	// ------------------------------------------------------------------------------------------------ 
	
	echo $paging_Html;
	echo $ListStart.$TableTitle;
	
	if ($NrfFlights>0) {
		$Line=0;
		// loop to display all rows 
		while ($row = mysql_fetch_assoc($result)) 
		{
			echo $TRList;
			// loop to display all columns using function "makeTD()" 
			for($i=0;$i<count($dbFieldNames);$i++) 
			{
				if ($dbFieldNames[$i]=='FlightId')
				{
					echo makeTD($row[$dbFieldNames[$i]],$dbFieldNames[$i],$Line,$FormatFlight[$i],$row['id']);	// this TD is linked by FlightId 
				} else {
					echo makeTD($row[$dbFieldNames[$i]],$dbFieldNames[$i],$Line,$FormatFlight[$i]);
				}
			}
			echo '</tr>';
			$Line=!$Line;		
		}
	} 
	else 
	{
		echo '<tr><td colspan="'.count($dbFieldNames).'" align="center"><br>There are no flights recorded.</td></tr>';
	}

	if ($action!="ALLFLIGHTS") {
		echo '<tr><td colspan="'.count($dbFieldNames).'" align="center" style="padding:5px 0px 5px 0px;font-weight:bold"><a href="javascript:history.back()">&laquo; return to '.$returnText.' list</a></td></tr>';
	}
	echo $ListStop;
	
	echo $paging_Html;
	echo	$TemplateEnd;
}
if(isset($Groupflight))return;
///////////////////// THIS IS THE SINGLE FLIGHT OUTPUT /////////////////////////////////////////////////////////// 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
if(isset($listflight))
{
	$query = "SELECT *, REPLACE(TotalDistance,',','') * 1.852 AS TotalDistanceKm FROM flights WHERE id=$listflight";
    $result=mysql_query($query);
	if(!$result){echo "SQL Error - ".mysql_error();return;}
	$NrfFlights=mysql_num_rows($result);
	if($NrfFlights==0){echo "No flights to display";return;}
	$Line=0;
	$row = mysql_fetch_assoc($result);
	$burn = $row["StartFuelQuantity"]-$row["EndFuelQuantity"].' kg';

	echo $TemplateStart;
	echo HtmlSelect();
	echo '<br>'.$ListStart;
	echo '<tr>'.$TDTitStyleList.'<strong>Company:&nbsp;</strong>'.$row["CompanyName"].'&nbsp;&nbsp;&nbsp;&nbsp;<strong>Flight Id:&nbsp;</strong>'.$row["FlightId"].'&nbsp;&nbsp;&nbsp;&nbsp;<strong>Flight Date:</strong>&nbsp;'.$row["FlightDate"].'&nbsp;&nbsp;&nbsp;&nbsp;<strong>Pilot:</strong>&nbsp;'.$row["PilotName"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Aircraft Name:</strong></td>'.$TDListOdd.$row["AircraftName"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Aircraft Type:</strong></td>'.$TDListEven.$row["AircraftType"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Departure:</strong></td>'.$TDListOdd.$row["DepartureIcaoName"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Arrival:</strong></td>'.$TDListEven.$row["ArrivalIcaoName"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Departure Time:</strong></td>'.$TDListOdd.$row["DepartureLocalHour"]." (".$row["DepartureGmtHour"]." GMT)</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Arrival Time:</strong></td>'.$TDListEven.$row["ArrivalLocalHour"]." (".$row["ArrivalGmtHour"]." GMT)<br></td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Passengers:</strong></td>'.$TDListOdd.$row["NbrPassengers"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Cargo:</strong></td>'.$TDListEven.$row["CargoWeight"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Flight Result:</strong></td>'.$TDListOdd.$row["FlightResult"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Take-Off Weight:</strong></td>'.$TDListEven.$row["StartAircraftWeight"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Landing Weight:</strong></td>'.$TDListOdd.$row["EndAircraftWeight"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Take-Off Fuel:</strong></td>'.$TDListEven.$row["StartFuelQuantity"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Landing Fuel:</strong></td>'.$TDListOdd.$row["EndFuelQuantity"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Fuel Burn:</strong></td>'.$TDListEven.$burn."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Total Distance:</strong></td>'.$TDListOdd.FormatCell($row["TotalDistanceKm"],'0')." km</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Total Time:</strong></td>'.$TDListEven.$row["TotalBlockTime"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Total Time Night:</strong></td>'.$TDListOdd.$row["TotalBlockTimeNight"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Total Airborn Time:</strong></td>'.$TDListEven.$row["TotalAirbornTime"]."</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Total Time On Ground:</strong></td>'.$TDListOdd.$row["TotalTimeOnGround"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Max Altitude:</strong></td>'.$TDListEven.$row["MaxAltitude"]."</td></tr>";
//	if($row["CruiseTimeStopSec"]>0)
//	{
		echo '<tr>'.$TDListOdd.'<strong>Cruise Speed:</strong></td>'.$TDListOdd.$row["CruiseSpeed"]."</td></tr>";
//		echo '<tr>'.$TDListOdd.'<strong>Cruise Mach Speed:</strong></td>'.$TDListOdd.$row["CruiseMachSpeed"]."</td></tr>";
//	}
//	if($row["LandingSpeed"]>0)
//	{
		echo '<tr>'.$TDListEven.'<strong>Landing Speed:</strong></td>'.$TDListEven.$row["LandingSpeed"]."</td></tr>";
		echo '<tr>'.$TDListOdd.'<strong>Landing Pitch:</strong></td>'.$TDListOdd.$row["LandingPitch"]."</td></tr>";
//	}
	echo '<tr>'.$TDListEven.'<strong>Touch Down:</strong></td>'.$TDListEven.$row["TouchDownVertSpeedFt"]." ft/mn</td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Captain Sent Mayday:</strong></td>'.$TDListOdd.$row["CaptainSentMayday"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Crash Flag:</strong></td>'.$TDListEven.$row["CrashFlag"]."</td></tr>";
	
	echo '<tr>'.$TDListOdd.'<strong>Passengers Opinion:</strong></td>'.$TDListOdd.$row["PassengersOpinion"]."%</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Passengers Opinion Text:</strong></td>'.$TDListEven.'-'.$row["PassengersOpinionText"]." </td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Failure Text:</strong></td>'.$TDListOdd.'-'.$row["FailureText"]."</td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Casualties Text:</strong></td>'.$TDListEven.'-'.$row["CasualtiesText"]." </td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Pilot Bonus:</strong></td>'.$TDListOdd.$row["BonusPoints"]." </td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Pilot Bonus Text:</strong></td>'.$TDListEven.'-'.$row["PilotBonusText"]." </td></tr>";
	echo '<tr>'.$TDListOdd.'<strong>Pilot Penality:</strong></td>'.$TDListOdd.$row["PenalityPoints"]." </td></tr>";
	echo '<tr>'.$TDListEven.'<strong>Pilot Penality Text:</strong></td>'.$TDListEven.'-'.$row["PilotPenalityText"]." </td></tr>";
	echo '<tr>'.$TDTitStyleList.'<a href="javascript:history.back()">&laquo; back</a></td>';
	echo '</table>';

	echo '<br>';
	echo $TemplateEnd;
}
if(isset($listflight))return;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////




/*******************************************************************************************************************/
//   Functions                                                                                                       
/*******************************************************************************************************************/	

// Formats input according to format argument
function FormatCell($data,$format)
{
	if ($format != '' AND $format != 'x' AND $format != 's' AND $format != 'l')
	{
		$data =	number_format($data, $format, '.', ' ');	
	} elseif ($format == 's')
	{
		// short iaco name
		$data=substr($data,0,4);
	} elseif ($format == 'l')
	{
		// long iaco name, if missing show short
		$txt=substr($data,7);
		if (trim($txt) == '') $txt = $data;
		$data = $txt;
	}
	return $data;
}

// this function generates the HTML for one cell (TD) in a table row 	
function makeTD($data,$fieldName,$evenodd,$format,$rowID=-1) 
{	global $linkColor;
	global $evenColor;
	global $oddColor;

	// set alternating background-colors 
	if($evenodd==1) {$bgColor = $evenColor;} else {$bgColor = $oddColor;}
	
	// automatic right-align for numeric values 
	if(is_numeric($data) && $fieldName!='FlightId') {$tdalign = 'align="right" ';} else {$tdalign = '';}
	
	$data = FormatCell($data,$format);
	
	// link through Flight-ID? 
	if($rowID>-1) $data = '<a href="?listflight='.$rowID.'" style="color:'.$linkColor.'">'.$data.'</a>';
	
	// return the HTML 
	$tdList = '<td nowrap '.$tdalign.'style="background-color:'.$bgColor.';padding:1px 5px 1px 5px">'.$data.'</td>'.chr(13);
	return $tdList;
}
function makeTD1($data, $fieldName, $evenodd, $format, $align, $rowID=-1) 
{	global $linkColor;
	global $evenColor;
	global $oddColor;
	global $action;

	// set alternating background-colors 
	if($evenodd==1) {$bgColor = $evenColor;} else {$bgColor = $oddColor;}
	
	// automatic right-align for numeric values 
	if(is_numeric($data) && $fieldName!='FlightId') {$tdalign = 'align="right" ';} else {$tdalign = '';}

	if ($align != '' AND $align != 'x')
	{
		if ($align == 'l')
		{
			$tdalign = 'align="left" ';
		} elseif ($align == 'r')
		{
			$tdalign = 'align="right" ';
		} elseif ($align == 'c')
		{
			$tdalign = 'align="center" ';
		}
	}

	$data = FormatCell($data,$format);

	// link through Group List 
	if($rowID>-1) $data = '<a href="?action='.$action.'&groupflight='.$rowID.'" style="color:'.$linkColor.'">'.$data.'</a>';
	
	// return the HTML
	$tdList = '<td nowrap '.$tdalign.' style="background-color:'.$bgColor.';padding:1px 5px 1px 5px">'.$data.'</td>'.chr(13);
	return $tdList;
}


// this function takes the accumulated kg and lbs weights, 
// puts them together and returns the total cargo in both units 
function getWeight($kg,$lb) 
{
	$LBtoKG = 0.4535924;
	$totalKG = $kg+($lb*$LBtoKG);
	$totalLB = $totalKG/$LBtoKG;
	$cwStr = number_format($totalKG,0).' kg / '.number_format($totalLB,0).' lbs';
	return $cwStr;
}

// this adds two hours of FsP and returns them in hour format 
// ( 12:30:45 + 02:05:06 = 14:35:51 for example)
// --- not used in this script --- 
function AddTime($Time1,$Time2)
{
	$timea=explode(":",$Time1);
	$timeb=explode(":",$Time2);
	$secondes=($timea[0]+$timeb[0])*3600;
	$secondes+=($timea[1]+$timeb[1])*60;
	$secondes+=$timea[2]+$timeb[2];
    $hours = floor($secondes / 3600);
    $minute = floor(($secondes - ($hours * 3600)) / 60);
    $secconde = $secondes - ($hours * 3600) - ($minute * 60);
  return sprintf("%02d:%02d:%02d", $hours, $minute, $secconde);
}

function VAStat() {
	////////////////////////////////////////////// STATISTICS ///////////////////////////////////////// 
	/// Get the total number of flights, total flight time, total passengers & total cargo weight    // 
	/////////////////////////////////////////////////////////////////////////////////////////////////// 

	global $TDListOdd;
	global $ListStop;

	$query = "select count(*) from flights ".$condition;
	$result=mysql_query($query);
	if(!$result){echo "SQL Error - ".mysql_error()."<br>".$query;return;}
	$NrfFlights=mysql_result($result,0);
	# total flight time / block time 
	$query = "SELECT sec_to_time(sum(time_to_sec(TotalBlockTime))) FROM flights ".$condition;
	$result=mysql_query($query);
	$TFT = number_format(mysql_result($result,0));
	# total passengers 
	$query = "SELECT sum(NbrPassengers) FROM flights ".$condition;
	$result=mysql_query($query);
	$TPC = number_format(mysql_result($result,0));
	# total cargo weight		// there might be units of lbs as well as kg in one database 
								// therefor each sum has to be read separately. 
								// we compute the total weight in one unit first and 
								// display both units in the stats 
	$query = "SELECT sum(CargoWeight) FROM flights where right(CargoWeight,2)='kg' ".$andCondition;
	$result=mysql_query($query);
	$TCKG = mysql_result($result,0);
	$query = "SELECT sum(CargoWeight) FROM flights where right(CargoWeight,3)='lbs' ".$andCondition;
	$result=mysql_query($query);
	$TCLB = mysql_result($result,0);
	$TCW = getWeight($TCKG,$TCLB);		// see function at end of script 
	
	
	return '<br><table width="300" cellspacing="1" cellpadding="2" align="center" style="font: normal 11px/14px Arial,sans-serif;padding:7px 7px 7px 7px">'.$TDListOdd.
		 "<div align=\"center\"><strong><u>Virtual Airline Statistics</u></strong><br>".
		 "Total flights".$startMsg.": $NrfFlights<br>
		 Total flight time: $TFT h<br>
		 Total passengers carried: $TPC<br>
		 Total Cargo carried: $TCW</div>".
		 $ListStop.'<br>';
}
?>
